package barrier;

import java.util.*;

public class BarrierSync
{
	private boolean armata = false;
	private boolean initDone = false;
	private Set<Thread> threadSet = null;
	int count = 0;
	int exitCount = 0;

	public BarrierSync()
	{
		threadSet = new HashSet<Thread>();
		initDone = false;
		count = 0;
	}

	public synchronized boolean register()
	{
		if(initDone)
		{
			throw new IllegalMonitorStateException("Barriera attivata, il gruppo non e' piu' modificabile");
		}
		return threadSet.add(Thread.currentThread());
	}

	public synchronized boolean deRegister()
	{
		if(initDone)
		{
			throw new IllegalMonitorStateException("Barriera attivata, il gruppo non e' piu' modificabile");
		}
		return threadSet.remove(Thread.currentThread());
	}

	public synchronized boolean init()
	{
		if(initDone)
		{
			throw new IllegalMonitorStateException("Barriera gia' attivata");
		}
		armata = true;
		return (initDone = true);
	}

	public synchronized boolean sync()
	{
		if(!initDone)
		{
			throw new IllegalMonitorStateException("Barriera non ancora attivata");
		}
		if(!threadSet.contains(Thread.currentThread()))
		{
			throw new IllegalArgumentException("Il thread " + Thread.currentThread().getName() + " non e' registrato in questa barriera");
		}
		/*
		if(!armata)
		{
			return false;
		}
		*/

		String name = Thread.currentThread().getName();

		count++;
		if(count < threadSet.size())
		{
			try
			{
				wait();
			}
			catch(InterruptedException ie)
			{
				ie.printStackTrace();
			}
			exitCount++;
			if(exitCount == threadSet.size())
			{
				//armata = true;
				exitCount = 0;
				System.out.println(name + " sono l'ultimo a svegliarmi");
			}
			else
			{
				System.out.println(name + " mi sveglio ma non sono l'ultimo a svegliarmi");
			}
		}
		else
		{
			System.out.println(name + " sveglio tutti");
			notifyAll();
			count = 0;
			//armata = false;
			exitCount = 1;
		}
		return true;
	}
}
