package locks;

import java.util.*;

//lock con attesa in caso di mancata acquisizione
public class MyLock4
{
	MyLock1 mutex = MyLock1();
	List<Thread> waiting = new LinkedList<Thread>();
	Thread locker = null;


	public boolean lock()
	{
		boolean rimosso = false;
		while(!mutex.tryLock());
		while(locker != null)
		{
			waiting.add(Thread.currentThread());
			mutex.unlock();
			//in questo istante io ho rilasciato il mutex e chiunque puo' agire. Funziona SOLO perche' interrupt ha memoria, cioe' interrompe la prima chiamata anche nel futuro.
			try
			{
				Thread.sleep(1000000);
				waiting.remove(Thread.currentThread());//ok, ma perdo la posizione in coda
			}
			catch(InterruptedException ie)
			{
				ie.printStackTrace();
			}
			while(!mutex.tryLock());
		}
		locker = Thread.currentThread();
		mutex.unlock();
		return true;
	}

	public boolean unlock()
	{
		while(!mutex.tryLock());
		if(locker != Thread.currentThread())
		{
			mutex.unlock();
			return false;
		}
		locker = null;
		if(waiting.size() > 0)
		{
			Thread inWait = waiting.remove();
			inWait.interrupt();
		}
		mutex.unlock();
	}
}
