package net;

import java.io.*;
import java.net.*;
import java.util.*;

public class ServerTCP3
implements Runnable
{
	ServerSocket ss;
	List<Socket> list;

	public ServerTCP3(int port) throws IOException
	{
		ss = new ServerSocket(port);
		list = new LinkedList<Socket>();
	}

	public ServerTCP3() throws IOException
	{
		this(1234);
	}

	public void exec() throws IOException
	{
		Socket s = null;
		while(true)
		{
			s = ss.accept();
			synchronized(list)
			{
				list.add(s);
			}
			(new Thread(this)).start();
		}
	}

	public void run()
	{
		Socket s = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;
		synchronized(list)
		{
			s = list.remove(0);
		}

		try
		{
			Object o = null;
			oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());
			while( (o = ois.readObject()) != null)
			{
				//String line = (String)o;
				System.out.println("Ho letto <" + o + "> rispondo ok");
				oos.writeObject("Ok");
				oos.flush();
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		catch(ClassNotFoundException cnfe)
		{
			cnfe.printStackTrace();
		}
		finally
		{
			try
			{
				ois.close();
				oos.close();
				s.close();
			}
			catch(IOException ioe2)
			{
				ioe2.printStackTrace();
				System.err.println("Piu' storta di cosi', neanche riesco a chiudere i canali...");
			}
		}
		System.out.println(Thread.currentThread().getName() + " adieu");
	}

	public static void main(String[] argv) throws IOException
	{
		ServerTCP3 serv = null;
		if(argv.length > 0)
		{
			serv = new ServerTCP3(Integer.parseInt(argv[0]));
		}
		else
		{
			serv = new ServerTCP3();
		}
		serv.exec();
	}
}
