package net;

import java.io.*;
import java.net.*;
import java.util.*;
import remotizzazione.Operazione;

public class ServerTCP4
implements Runnable
{
	ServerSocket ss;
	List<Socket> list;

	public ServerTCP4(int port) throws IOException
	{
		ss = new ServerSocket(port);
		list = new LinkedList<Socket>();
	}

	public ServerTCP4() throws IOException
	{
		this(1234);
	}

	public void exec() throws IOException
	{
		Socket s = null;
		while(true)
		{
			s = ss.accept();
			synchronized(list)
			{
				list.add(s);
			}
			(new Thread(this)).start();
		}
	}

	public void run()
	{
		Socket s = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;
		synchronized(list)
		{
			s = list.remove(0);
		}

		try
		{
			Object o = null;
			oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());
			while( (o = ois.readObject()) != null)
			{
				//String line = (String)o;
				System.out.println("Ho letto <" + o + "> eseguo");

				Operazione op = (Operazione)o;
				switch(op.operazione)
				{
					case 0:
						op.result = op.d1 + op.d2;
						break;
					case 1:
						op.result = op.d1 - op.d2;
						break;
					case 2:
						op.result = op.d1 * op.d2;
						break;
					case 3:
						op.result = op.d1 / op.d2;
						break;
					default:
						System.err.println("Operazione " + op.operazione + " non nota");
				}
				oos.writeObject(op);
				oos.flush();
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		catch(ClassNotFoundException cnfe)
		{
			cnfe.printStackTrace();
		}
		finally
		{
			try
			{
				ois.close();
				oos.close();
				s.close();
			}
			catch(IOException ioe2)
			{
				ioe2.printStackTrace();
				System.err.println("Piu' storta di cosi', neanche riesco a chiudere i canali...");
			}
		}
		System.out.println(Thread.currentThread().getName() + " adieu");
	}

	public static void main(String[] argv) throws IOException
	{
		ServerTCP4 serv = null;
		if(argv.length > 0)
		{
			serv = new ServerTCP4(Integer.parseInt(argv[0]));
		}
		else
		{
			serv = new ServerTCP4();
		}
		serv.exec();
	}
}
