package rmi;

import java.rmi.*;
import java.rmi.server.*;
import net.*;

public class CounterImpl
extends UnicastRemoteObject
implements Counter
{
	int count = 0;

	public CounterImpl() throws RemoteException
	{
		super();
	}

	public int count() throws RemoteException
	{
		System.out.println("count");
		whoami();
		mySleep(1000);
		return count;
	}

	public int inc() throws RemoteException
	{
		System.out.println("inc");
		whoami();
		mySleep(1000);
		count++;
		return count;
	}

	public int add(int val) throws RemoteException
	{
		System.out.println("add " + val);
		whoami();
		mySleep(1000);
		count+=val;
		return count;
	}

	public IntHolder add(IntHolder ih, int val) throws RemoteException
	{
		System.out.println("add " + ih + " " + val);
		whoami();
		mySleep(1000);
		ih.value += val;
		return ih;
	}

	public void mySleep(long millis)
	{
		try
		{
			Thread.sleep(millis);
		}
		catch(InterruptedException ie)
		{
			ie.printStackTrace();
		}
	}

	public void whoami()
	{
		System.out.println(Thread.currentThread().getName());
	}
}
